var sys = require('sys');
var http = require('http');
var rpio = require('rpio');
var qs = require('querystring');
var url = require('url');
var fs = require('fs');


fs.readFile('./template.html', function(err, html) {
if (err)
{
	throw err;
}

var server = http.createServer(
	function (request, response) {

	
		
	if( request.method == 'GET')
	{
		var url_parts = url.parse(request.url, true);
		//console.log(url_parts.query.CMD);


		//Parse GET_Commands from Desktop Station
		ParseDSCommand(url_parts.query.CMD);
	}	



	response.writeHead(200, {'Content-Type': 'text/html'});
	//response.writeHead(200, {'Connection': 'close'});

	response.write('<!-- 200 Ok -->\n');
	response.write(html);
	response.end();
}
).listen(8124);
});

sys.log('Server running at http://127.0.0.1:8124/');


function ParseDSCommand(inStrCommand)
{
	var strCommand = "";

	if( inStrCommand == null)
	{
		return false;
	}

	strCommand = inStrCommand; //"setLocoSpeed(49153,100)";

	//console.log("Log: " + strCommand);

	strCommand = strCommand.replace("(",",");
	strCommand = strCommand.replace(")",",");
	var strParameters = strCommand.split(",");
	var aOutBuf = new Buffer(8);
	aOutBuf.fill(0);

	console.log("Func: " + strParameters[0] +
	", " + strParameters[1] +
	", " + strParameters[2] +
	", " + strParameters[3] +
	", " + strParameters[4]);

	if( strParameters[0] == "setLocoSpeed")
	{
		var aAddr = parseInt(strParameters[1]);
		var aSpeed = parseInt(strParameters[2]);
	
		//console.log(aAddr.toString());
		//console.log(aSpeed.toString());
		
		aOutBuf[0] = 16 + 6;//0b00010000;
		aOutBuf[1] = aAddr & 0xFF;
		aOutBuf[2] = (aAddr >> 8) & 0xFF;
		aOutBuf[3] = aSpeed & 0xFF;
		aOutBuf[4] = (aSpeed >> 8) & 0xFF;
		aOutBuf[5] = GenerateCRC(aOutBuf, 5);

		exchangeMessage(aOutBuf);
		
	}
	else if( strParameters[0] == "setLocoSpeedEx")
	{
		var aAddr = parseInt(strParameters[1]);
		var aSpeed = parseInt(strParameters[2]);
		var aSpeedStep = parseInt(strParameters[3]);
	
		//console.log(aAddr.toString());
		//console.log(aSpeed.toString());
		
		aOutBuf[0] = 16 + 7;
		aOutBuf[1] = aAddr & 0xFF;
		aOutBuf[2] = (aAddr >> 8) & 0xFF;
		aOutBuf[3] = aSpeed & 0xFF;
		aOutBuf[4] = (aSpeed >> 8) & 0xFF;
		aOutBuf[5] = aSpeedStep;
		aOutBuf[6] = GenerateCRC(aOutBuf, 6);

		exchangeMessage(aOutBuf);
		
	}
	else if( strParameters[0] == "setPower")
	{
		
		if( strParameters[1] == "1")
		{
			aOutBuf[0] = 240 + 2;//0b11110000;
		}
		else
		{
			aOutBuf[0] = 0 + 2;//0b00000000;
		}		
		
		aOutBuf[1] = aOutBuf[0];

		exchangeMessage(aOutBuf);		
		
	}
	else if( strParameters[0] == "setLocoDirection")
	{
		var aAddrDir = parseInt(strParameters[1]);
		var aDir = parseInt(strParameters[2]);
		
		aOutBuf[0] = 80 + 5;
		aOutBuf[1] = aAddrDir & 0xFF;
		aOutBuf[2] = (aAddrDir >> 8) & 0xFF;
		aOutBuf[3] = aDir - 1;
		aOutBuf[4] = GenerateCRC(aOutBuf, 4);

		exchangeMessage(aOutBuf);		
		
		
		
	}
	else if( strParameters[0] == "setLocoFunction")
	{
		
		var aAddrFnc = parseInt(strParameters[1]);
		var aFuncNo = parseInt(strParameters[2]);
		var aFuncPw = parseInt(strParameters[3]);
		
		aOutBuf[0] = 48 + 6;
		aOutBuf[1] = aAddrFnc & 0xFF;
		aOutBuf[2] = (aAddrFnc >> 8) & 0xFF;
		aOutBuf[3] = aFuncNo + 1;
		aOutBuf[4] = aFuncPw;
		aOutBuf[5] = GenerateCRC(aOutBuf, 5);

		exchangeMessage(aOutBuf);		
		
		
	}
	else if( strParameters[0] == "setTurnout")
	{
		var aAccAddr = parseInt(strParameters[1]);
		var aAccSwitch = parseInt(strParameters[2]);
		
		aOutBuf[0] = 32 + 6;
		aOutBuf[1] = aAccAddr & 0xFF;
		aOutBuf[2] = (aAccAddr >> 8) & 0xFF;
		aOutBuf[3] = 0;
		aOutBuf[4] = SwapAccSwitch(aAccAddr, aAccSwitch);
		aOutBuf[5] = GenerateCRC(aOutBuf, 5);

		exchangeMessage(aOutBuf);
		
	}
	else if( strParameters[0] == "setLocoConfig")
	{
		var aAddr = parseInt(strParameters[1]);
		var aCVNo = parseInt(strParameters[2]);
		var aCVValue = parseInt(strParameters[3]);

		var aOffsetCVAddr = 0;

		if( aAddr >= 49152)
		{
			aOffsetCVAddr = aCVNo;
		}
		else
		{
			aOffsetCVAddr = aCVNo | 0x8000;
		}


		
		aOutBuf[0] = 64 + 5;
		aOutBuf[1] = aOffsetCVAddr & 0xFF;
		aOutBuf[2] = (aOffsetCVAddr >> 8) & 0xFF;
		aOutBuf[3] = aCVValue;
		aOutBuf[4] = GenerateCRC(aOutBuf, 4);

		exchangeMessage(aOutBuf);
		
	}

}

function exchangeMessage(inPackets)
{
	var aCounter = 0;

	while( aCounter < 10)
	{

		if( SPISend(inPackets) == true)
		{
			return true;
			//break;
		}
	
		setTimeout(5);
		aCounter++;

	}

	return false;
}

function GenerateCRC(inBuf, inLen)
{
	var aCRC = inBuf[0];

	for( var i = 1; i < inLen; i++)
	{
		aCRC = aCRC ^ inBuf[i];
	}

	return aCRC;

}

function SwapAccSwitch(inAccAddr, inSwitch)
{
	var aHighAddr = (inAccAddr >> 8);

	if( (aHighAddr >= 0x30) && (aHighAddr <= 0x33))
	{
		//MM2 Accessories
		if( inSwitch == 0)
		{
			return 1; //Diverging
		}
		else
		{
			return 0; //Straight
		}

	}
	else if( (aHighAddr >= 0x38) && (aHighAddr <= 0x3F))
	{
		//DCC Accessories
		return inSwitch;
	}
	else
	{
		return inSwitch;
	}
	
	
}

function SwapByte(inByte)
{
	var aRetByte = 0;

	for( var i = 0; i < 8; i++)
	{
		aRetByte = aRetByte + (((inByte >> i) & 1) << (7 - i));
	}
	
	return aRetByte;
	//return inByte;

}

function SPISend(inSendBuf)
{
	var aOutBuf = new Buffer(8);
	var aInBuf = new Buffer(8);
	aOutBuf.fill(0);

	aInBuf[0] = SwapByte(inSendBuf[0]);
	aInBuf[1] = SwapByte(inSendBuf[1]);
	aInBuf[2] = SwapByte(inSendBuf[2]);
	aInBuf[3] = SwapByte(inSendBuf[3]);
	aInBuf[4] = SwapByte(inSendBuf[4]);
	aInBuf[5] = SwapByte(inSendBuf[5]);
	aInBuf[6] = SwapByte(inSendBuf[6]);
	aInBuf[7] = SwapByte(inSendBuf[7]);

	console.log("SendTo: Len " + aInBuf.length.toString() +
	", Frame " + aInBuf[0].toString() +
	", " + aInBuf[1].toString() +
	", " + aInBuf[2].toString() +
	", " + aInBuf[3].toString() +
	", " + aInBuf[4].toString() +
	", " + aInBuf[5].toString() +
	", " + aInBuf[6].toString());

//	console.log("Send \""+aInBuf.toString()+"\" to.");
	

	rpio.spiBegin();
	rpio.spiChipSelect(0);
	rpio.spiSetCSPolarity(0, rpio.LOW);
	rpio.spiSetClockDivider(256);
	rpio.spiSetDataMode(1);

	
	aOutBuf = rpio.spiTransfer(aInBuf, aInBuf.length);

	rpio.spiEnd();
		
	console.log("BackFrom: Len " + aOutBuf.length.toString() +
	", Frame " + SwapByte(aOutBuf[0]).toString() +
	", " + SwapByte(aOutBuf[1]).toString() +
	", " + SwapByte(aOutBuf[2]).toString() +
	", " + SwapByte(aOutBuf[3]).toString() +
	", " + SwapByte(aOutBuf[4]).toString() +
	", " + SwapByte(aOutBuf[5]).toString() +
	", " + SwapByte(aOutBuf[6]).toString());
	
	//Check the reply message from DSCore
	
	console.log("-------");
	
	return true;
}
